/* 
 * Universidade do Estado do Rio de Janeiro
 * Faculdade de Engenharia 
 * Departamento de Sistemas e Computacao
 * Autora: Elaine de M. Silva
 * Projeto de Graduacao - Adequacao do Software 
 * de Simulacao Scicos para a Aquisicao de Dados
 * e o Controle em Tempo Real
 * -------------------------------------------------------------------------------------------
 * Comedi acquisition server: message sender module. Wraps in HTML protocol and sends messages
 * to client. 
 *                    
 * Revision 1.1  2009/08/03 02:00:12  elaine
 * Initial revision
 *
 * Revision 1.2  2009/12/05 12:39:19  elaine
 * Minor enhancements 
 * 
 * -------------------------------------------------------------------------------------------
 *
 */

/* required header files */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stddef.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <comedilib.h>    // provides comedi functions 
#include <time.h> 
#include "includes/comedisrv.h"    // provides modified comedi functions

const char *htmlHeader = "HTTP/1.0 200 OK\n\n";

int sendMsg(char *onStatus, const char *msg, int sock, int size){

	char *sendBuffer = malloc(sizeof(char) * size + strlen(htmlHeader) + strlen(onStatus) + 1);
	int sentBytes = 0;
	bzero(sendBuffer,sizeof(char) * size + strlen(htmlHeader) + strlen(onStatus) + 1); // clears sendBuffer
	strcat(sendBuffer,htmlHeader);
	strcat(sendBuffer,onStatus);
	strcat(sendBuffer,msg);
	
	if ((strlen(sendBuffer)) >= (strlen(htmlHeader) + strlen(msg))){
		sentBytes = write(sock,sendBuffer,strlen(sendBuffer));
	}

	close(sock); // closes socket since all data has been sent. 
	free(sendBuffer);
	sendBuffer = NULL;

	return sentBytes;
			
}
