/* 
 * Universidade do Estado do Rio de Janeiro
 * Faculdade de Engenharia 
 * Departamento de Sistemas e Computacao
 * Autora: Elaine de M. Silva
 * Projeto de Graduacao - Adequacao do Software 
 * de Simulacao Scicos para a Aquisicao de Dados
 * e o Controle em Tempo Real
 * -------------------------------------------------------------------------------------------
 * Comedi acquisition server: message receiver module. Stores messages from client on buffer
 * 
 * Revision 1.1  2009/08/03 01:49:59  elaine
 * Initial revision
 *
 * Revision 1.2  2009/12/05 11:44:10  elaine
 * Minor enhancements
 * 
 * -------------------------------------------------------------------------------------------
 *
 */

/* required header files */ 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stddef.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <comedilib.h>   // provides comedi function
#include "includes/comedisrv.h"   // provides comedi modified functions and constants


int getClientData(int sock, int newSockfd, char buff[], int lim){

	/* variables */
	int bytesRead = 0;
	int numbytes = 0;
	char buffAux[lim];  

	/* clears buffers */
	bzero(buffAux,lim*sizeof(char));  
	bzero(buff, lim*sizeof(char)); 


	// reads client's message, in failure restarts connection    
	while((numbytes=read(newSockfd,buff,lim - 1))!= 0 ){
		if(numbytes == -1){
			perror("read");
			return -1;
			break;
		}

		buff[numbytes] = '\0';
		strcat(buffAux,buff); // receives all data  
		//bzero(buff,lim*sizeof(char)); // cleans buffer 
		bytesRead = bytesRead + numbytes;
		
		// stops the loop when there is no more data to be read
		// TODO retirar este bloco quando algoritmo estiver corrigido, o laco deve parar quando o token de final de request chegar.
		if(numbytes < (lim -1)){
			break;
		}

	}

	strcpy(buff,buffAux);

	return 0;

}
