function [x,y,typ] = COMEDI_NET_AN_OUT(job,arg1,arg2)

x=[]; y=[]; typ=[];

select job 

case 'plot' then    
  standard_draw(arg1)
  
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)  

case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)  

case 'getorigin' then
  [x,y]=standard_origin(arg1)      

case 'set' then
  x = arg1;
  graphics = arg1.graphics; exprs= graphics.exprs
  model = arg1.model; 
  
 ip = exprs(2)
 dev = exprs(3)

  parms = ['IP'; 'device';'subdevice'; 'channel'; 'range';'aref'];

  //dialog box to set parameters 
  while %t do
    [ok, ip1, dev1, subdev1,chan1,rng1,aref1,exprs]=..
    getvalue('Parms - remote analog data output',..
    parms, list('str',1,'str',1,'str',1,'str',1,'str',1),exprs)
    
    if ~ok then break,end //user cancels modifications
        
        
    ip1 = stripblanks(ip1);
    
    dev1 = stripblanks(dev1);
    
    subdev1 = stripblanks(subdev1);
    
    chan1 = stripblanks(chan1);
   
    rng1 = stripblanks(rng1);	 
    aref1 = stripblanks(aref1);
    

      if length(dev1) < 1 then
	message('Please specify the device number')
    end

    if length(ip1) < 1 then
        message('Please specify a valid IP address')
  end
  
     if length(subdev1) < 1 then
        message('Please specify the subdevice')
   end
  
     if length(chan1) < 1 then
        message('Please specify the channel')
 end
 
    if length(rng1) < 1 then
        message('Please specify the range')
end
 if length(aref1) < 1 then
        message('Please enter a reference. Valid values are AREF_GROUND, AREF_COMMON, AREF_DIFF or AREF_OTHER')
end





      
    funam = 'comedi_net_an_out';
    funtyp = 4; 
    xx = [];
    ng = [];
    z  = 0 ;
    nx = 0;
    nz = 0;
      i=1;
      o = []; 
      //nout = 1;
      ci=1; nevin=1;
      co=[]; nevout=0;

    depu=%t;
    dept=%f;
    dep_ut=[depu dept];
    
   // cout = 1;
    
    [model,graphics,ok] = check_io(model,graphics,i,o,ci,co)
    
    if ok then
   model.sim = list(funam, funtyp) // simulating function 
  model.in = i ; //no input 
      model.out = o ; // output
      model.evtin = ci ; //event input 
      model.evtout=[]  ; //no event output 
      model.state=[]   ; //no state 
      model.dstate=0   ; //no discrete state 
      model.rpar=[]    ; //no real parameter 
      
      model.ipar= [length(ip1); //integer parameters
                   length(dev1);
               	   length(subdev1);
                   length(chan1);
		 length(rng1);	
		 length(aref1);
                   str2code(ip1);
                   str2code(dev1);
                   str2code(subdev1);
                   str2code(chan1);
                   str2code(rng1);
                   str2code(aref1)]
                                
      
      model.firing=[]  ; // no firing vector
      model.dep_ut = dep_ut ; // 
      model.nzcross = 0
      x.model = model
      graphics.exprs = exprs;
      x.graphics = graphics
      break ;  
    end
    
  end //of the while 
  
case 'define' then

ip = '127.0.0.1';
dev = '0';
subdev = '0';
chan = '0';
rng = '0';
aref = 'AREF_GROUND';


//  name="Parms - remote analog data input"

  model = scicos_model()
  funam = 'comedi_net_an_out';
  funtyp = 4; 
  model.sim = list(funam, funtyp) //simulating function
  
  model.in=1
  model.out=[]
  
  model.evtin=1
  model.evtout=[]
  
  model.state=[]
  model.dstate=[]
  model.rpar=[]
  

 
model.ipar= [length(ip);
             length(dev);
	    length(subdev);
             length(chan);
             length(rng);	
             length(aref);
             str2code(ip);
             str2code(dev);
             str2code(subdev);
             str2code(chan);
             str2code(rng);
             str2code(aref)]

  model.blocktype='c'
  
  model.firing = []
  model.dep_ut = [%t %f]
  model.nzcross=0

  exprs = [ip;dev;subdev;chan;rng;aref]
  gr_i = ['xstringb(orig(1),orig(2),[''remote analog data output''],sz(1),sz(2),''fill'');']
  
  x = standard_define([3 2], model, exprs, gr_i);

end

endfunction

