/* 
 * Universidade do Estado do Rio de Janeiro
 * Faculdade de Engenharia 
 * Departamento de Sistemas e Computacao
 * Autora: Elaine de M. Silva
 * Projeto de Graduacao - Adequacao do Software 
 * de Simulacao Scicos para a Aquisicao de Dados
 * e o Controle em Tempo Real
 * -------------------------------------------------------------------------------------------
 * Comedi acquisition server: message handler module. Parses messages from client to get the 
 * function to be executed.
 *
 * Revision 1.1  2009/08/03 01:59:21  elaine
 * Initial revision
 *
 * Revision 1.2  2009/12/05 12:33:09  elaine
 * Minor enhancements
 * 
 * -------------------------------------------------------------------------------------------
 *
 */

/* required header files */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stddef.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <comedilib.h>    // provides comedi functions
#include "includes/comedisrv.h"    // provides comedi modified functions and constants


int parser(char *buffer, int lim, char **par) {

	const char *delimiters = " /";
	char *token;
	int tokenCount = 0;

	// separates tokens delimited by " " and "/"
	for (token = strtok(buffer, delimiters); (token != NULL) && (tokenCount < lim) ; token = strtok(NULL, delimiters)) {

		if (!strcmp(token,"HTTP")) // parameters are defined until HTTP 
			break;

		par[tokenCount] = token;
		tokenCount++;
		//printf("token [%d] = '%s'\n",tokenCount - 1, par[tokenCount - 1]);

		
	}


	if (tokenCount < 3) {
		return -1;
	}

	if (strcmp(par[0], "GET") != 0) {
		return -2;
	}

	if (strstr(par[1], "comedi_") == NULL) {
		return -3;
	}

	//printf("Number of tokens: %d\n",tokenCount);
	return tokenCount;
}
