/*
 * Universidade do Estado do Rio de Janeiro
 * Faculdade de Engenharia
 * Departamento de Sistemas e Computacao
 * Autora: Elaine de M. Silva
 * Projeto de Graduacao - Adequacao do Software
 * de Simulacao Scicos para a Aquisicao de Dados
 * e o Controle em Tempo Real
 * ------------------------------------------------------------------------------------------
 *  Comedi acquisition client: Connect to server. 
 *
 *  Revision 1.1  2009/06/209 00:00:00  elaine
 *  Initial revision
 *
 *  Revision 1.2  2009/12/05  00:00:00  elaine
 *  Minor enhancements
 *
 *  -----------------------------------------------------------------------------------------
 *
 */

/* required header files */
#include "../includes/stack-c.h" // Scilab stack functions
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/tcp.h>
#include <sys/wait.h>
#include "../includes/comedisrv.h"  // provides comedi modified functions and constants


void closeSocketWhenRequested(int sockfd){
int stat;

	struct linger linger;
	linger.l_onoff = 0;
	linger.l_linger = 1;
	
		stat = setsockopt(sockfd, SOL_SOCKET, SO_LINGER, &linger, sizeof(linger));
		if(stat < 0){
			perror("setsockopt(SO_LINGER) failed");
			exit(1);
			}
}


void allowPortReuse(int sockfd){

int stat, yes = 1;

		//prevents "in use" message
		stat = setsockopt(sockfd, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int));
		if (stat < 0){
			perror("setsockopt(SO_REUSEADDR) failed");
			exit(1);
		}
}


void noDelaySendPackage(int sockfd){

int stat, nodelay = 1;

		//prevents "in use" message
		stat = setsockopt(sockfd, SOL_TCP, TCP_NODELAY, &nodelay, sizeof(nodelay));
		if (stat < 0){
			perror("setsockopt(TCP_NODELAY) failed");
			exit(1);
		}
}



//deprecated, do not use!
int connectToServer(char *ip){

  newConnectToServer(ip, SERVER_PORT);

}

int newConnectToServer(char *ip, int port){

	int sockfd = -1, stat;
	
	struct sockaddr_in servAddr;
	
		
	if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0){
			perror("client: socket\n");
			return -1;
			}
			

//	closeSocketWhenRequested(sockfd);
    allowPortReuse(sockfd);
    noDelaySendPackage(sockfd);
    
    bzero(&servAddr, sizeof(servAddr));
    servAddr.sin_family = AF_INET;
    servAddr.sin_port = htons(port);
    
    if(inet_pton(AF_INET, ip, &servAddr.sin_addr) <= 0){
      fprintf(stderr,"inet_pton: error for %s\n",ip);
    }
    
    if(connect(sockfd,(struct sockaddr *) &servAddr, sizeof(servAddr)) < 0){
			perror("connect: could not connect to socket\n");
			close(sockfd);
			return -1;
			}
			
return sockfd;

}


