/*
 * Universidade do Estado do Rio de Janeiro
 * Faculdade de Engenharia 
 * Departamento de Sistemas e Computacao
 * Autora: Elaine de Mattos Silva
 * Projeto de Graduacao - Adequacao do Software
 * de Simulacao Scicos para Aquisicao de Dados
 * e o Controle em Tempo Real
 * ------------------------------------------------------------------------------------------
 * Comedi acquisition client: Gets driver version code remotely. 
 * 
 * Revision 1.1  2009/12/20  18:11:00 elaine
 * Initial revision *
 *
 * ------------------------------------------------------------------------------------------
 *
 */


/* required header files */
#include "../includes/stack-c.h" // provides Scilab stack functions
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include "../includes/comedisrv.h"  // provides comedi modified functions and constants


void getBoardVersion(char *ip,char *dev, char **recvVersion, int *m3){

	int sentBytes, receiveStatus;
	int sockfd = -1, rc = -1;
	char *getVerStat, *getVerMsg;
	char * openMsg, *openStat, *recvOpen;
	int openFlag = 0;
	
	if ((openMsg  = (char *)malloc((unsigned)(BUFFERSIZE * sizeof(char)))) == NULL){
		printf("Not enough space to allocate openMsg\n");
		exit(1);
		}
	if ((openStat = (char *)malloc((unsigned)(BUFFERSIZE * sizeof(char)))) == NULL){
		printf("Not enough space to allocate openStat\n");
		exit(1);
	        }
	if ((recvOpen = (char *) malloc((unsigned)(BUFFERSIZE * sizeof(char)))) == NULL){
		printf("Not enough space to allocate recvOpen\n");
		exit(1);
		}
	if((getVerStat = (char *) malloc ((unsigned)(BUFFERSIZE * sizeof(char)))) == NULL){
		printf("getBoardVersion: Not enough space to allocate getVerStat\n");
		exit(1);
		}

	if((getVerMsg = (char *) malloc ((unsigned) (BUFFERSIZE * sizeof(char)))) == NULL){
		printf("getBoardVersion: Not enough space to allocate getVerMsg\n");
		exit(1);
		}

	if((*recvVersion = (char *) malloc((unsigned) (BUFFERSIZE * sizeof(char)))) == NULL){
		printf("getBoardVersion: Not enough space to allocate recvVersion\n");
		exit(1);
	}


                           /*
			 * opens device 
			 */
			 
			/* establishes a connection with the server. If not possible, exits */
			if ((sockfd = connectToServer(ip)) > 0){
		

				/* assembles message to send to server */
				remoteComediOpen(dev,openMsg);

				/* sends message to server. If the number of bytes is more than 0 receives 
				 * message from server. If not, exits */
				if((sentBytes = clientSender(sockfd,openMsg)) >=  0){
					
					/* receives msg from server. If the number of bytes read is more than 
					 * 0 checks the return code from comedi_open executed remotely and the 
					 * msg returned. If not, exits. */
					if ((receiveStatus = clientReceiver(sockfd,openStat)) > 0){

						/* checks the status of the comedi_open function. If status ok 
						 * the program continues. If not ok program aborts */

						//printf("client:valor do socket %d\n",sockfd);
						rc = checkCmdStatus(openStat, recvOpen);
						if (rc != 0){
							//printf("It was not possible to open the device!%s\n",recvOpen);
							bzero(*recvVersion, BUFFERSIZE * sizeof(char));
                                            	                 strcat(*recvVersion, "It was not possible to open the device!");
                                            	                 strcat(*recvVersion, recvOpen);		                
                                            		                 *m3 = strlen(*recvVersion);
                                            		                 return(0);
							}
						else{
						//printf("comedi_open message: '%s'\n",recvOpen);
						openFlag = 1;
						}

					}

					else{
						//printf("It was not possible to receive message from server\n");
						bzero(*recvVersion, BUFFERSIZE * sizeof(char));
                                            	        *recvVersion = "It was not possible to receive message from server";
                                  		                 *m3 = strlen(*recvVersion);
                                  		                 return(0);
						}
					}
				else{
						//printf("It was not possible to send message: '%s' to server\n",openMsg);
						bzero(*recvVersion, BUFFERSIZE * sizeof(char));
                                            	        strcat(*recvVersion,"It was not possible to send message: ");
                                  		                 strcat(*recvVersion, openMsg);
                                  		                 *m3 = strlen(*recvVersion);
                                  		                 return(0);
					}
				close(sockfd);

							

			}
			else{
                                  // printf("Open: It was not possible to open a connection with %s\n",ip);
                                 		//exit(1);
                                 		bzero(*recvVersion, BUFFERSIZE * sizeof(char));
		                 strcat(*recvVersion, "Open: It was not possible to open a connection with ");
		                 strcat(*recvVersion, ip);		                
		                 *m3 = strlen(*recvVersion);
		                 return(0);
			}
			

	/* tries to connect to server. On success sends acquisition request */
	if (((sockfd = connectToServer(ip)) > 0) && (openFlag = 1)) {
		remoteGetVersion(dev,getVerMsg); // assembles message to send 
		if ((sentBytes = clientSender(sockfd,getVerMsg)) >= 0){	// sends message to socket, returns number of bytes sent

			if ((receiveStatus = clientReceiver(sockfd,getVerStat)) > 0) {  // receives message from server,returns number of bytes read and closes socket 

				//printf("depois do receive\n");
				rc = checkCmdStatus(getVerStat,*recvVersion); // strips message from HTML protocol, strips into return code and message

				//printf("Antes de receber string de volta\n");
				//printf("Msg de volta %s\n",*recvVersion);

				if (rc == 0){
					*m3 = strlen(*recvVersion);
					}
				if (rc == -1){
				*m3 = strlen(*recvVersion);
				return(0);

					}
				} // end of clientReceiver if
				else{
				//printf("It was not possible to receive message from server\n");
						bzero(*recvVersion, BUFFERSIZE * sizeof(char));
                                            	        *recvVersion = "It was not possible to receive message from server";
                                  		                 *m3 = strlen(*recvVersion);
                                  		                 return(0);
                                  		                 }
			} // end of clientSender if
			else{
			//printf("It was not possible to send message: '%s' to server\n",openMsg);
						bzero(*recvVersion, BUFFERSIZE * sizeof(char));
                                            	        strcat(*recvVersion,"It was not possible to send message: ");
                                  		                 strcat(*recvVersion, openMsg);
                                  		                 *m3 = strlen(*recvVersion);
                                  		                 return(0);
                                  		                 }
                                  		                 
	}//end of the connectToServer if 
	else{
                                   //printf("Open: It was not possible to open a connection with %s\n",ip);
                                 		//exit(1);
                                 		bzero(*recvVersion, BUFFERSIZE * sizeof(char));
		                 strcat(*recvVersion, "Open: It was not possible to open a connection with ");
		                 strcat(*recvVersion, ip);		                
		                 *m3 = strlen(*recvVersion);
		                 return(0);
			}


	//printf("Antes dos frees\n");
	free(openStat);
	free(openMsg);
	free(recvOpen);
	free(getVerStat);
	free(getVerMsg);
	openStat = NULL;
	openMsg = NULL;
	getVerStat = NULL;
	getVerMsg = NULL;
	recvOpen = NULL;
	//printf("depois dos frees\n");


	
}

